#include "mywindow.h"
#include <iostream>
#include <hildonmm/stackable-window.h>
#include <hildonmm/window-stack.h>
#include <gtkmm.h>
#include "/usr/include/gtkmm-2.4/gtkmm/image.h"

MyWindow::MyWindow() :
	mapbutton_(Gtk::Hildon::SIZE_AUTO| Gtk::Hildon::SIZE_FINGER_HEIGHT,
       Hildon::BUTTON_ARRANGEMENT_VERTICAL,
       "See map"),

  pickerbutton_(Gtk::Hildon::SIZE_HALFSCREEN_WIDTH|
    Gtk::Hildon::SIZE_FINGER_HEIGHT, Hildon::BUTTON_ARRANGEMENT_VERTICAL),

       inspectbutton_(Gtk::Hildon::SIZE_AUTO | Gtk::Hildon::SIZE_FINGER_HEIGHT,
           Hildon::BUTTON_ARRANGEMENT_VERTICAL,
           "Inspect"),

           tb_(Gtk::Hildon::SIZE_HALFSCREEN_WIDTH |
               Gtk::Hildon::SIZE_FINGER_HEIGHT),

               chkButton_(Gtk::Hildon::SIZE_AUTO |
                   Gtk::Hildon::SIZE_FINGER_HEIGHT)
           {


	//Title
	set_title("Construction Monitoring System");

	hBox_.add(chkButton_);



	Glib::RefPtr<Gtk::ListStore> list_store =
	Gtk::ListStore::create(object_columns_);
	Glib::RefPtr<Hildon::TouchSelectorColumn> name_column =
	touchselector_.append_text_column(list_store);
	name_column->set_property("text-column", 0);

	name_column->pack_start(object_columns_.address_, false);


	// Populate the TreeModel with data:
	Gtk::TreeModel::Row row = *(list_store->append());


	//POPULATION
	row[object_columns_.name_] = "LUT";
	row[object_columns_.address_] = "Skinnarilankatu,";
	row = *(list_store->append());

	row[object_columns_.name_] = "Kauppakeskus Galleria";
	row[object_columns_.address_] = "Lappeenkatu,";
	row = *(list_store->append());

	row[object_columns_.name_] = "Finn Avia";
	row[object_columns_.address_] = "Pilotinkatu,";
	row = *(list_store->append());

	row[object_columns_.name_] = "Bang & Olufsen";
	row[object_columns_.address_] = "Hovedstadsområdet,";
	row = *(list_store->append());

	row[object_columns_.name_] = "Lappeenrannan Museo";
	row[object_columns_.address_] = "Kristiinanaukio, ";
	row = *(list_store->append());

	row[object_columns_.name_] = "Goblin";
	row[object_columns_.address_] = "Ulica 54, 54645 Gorod";
	row = *(list_store->append());

  //________________________________


  pickerbutton_.set_selector(touchselector_);
  pickerbutton_.set_title("Pick a site");

  chkButton_.set_label("Check Me");


  box_.add(mapbutton_);
  box_.add(pickerbutton_);
  box_.add(inspectbutton_);

  add(box_);

  pickerbutton_.signal_value_changed().connect(
    sigc::mem_fun(*this, &MyWindow::on_value_changed));

  inspectbutton_.signal_clicked().connect(
        sigc::mem_fun(*this, &MyWindow::view_inspection));

  mapbutton_.signal_clicked().connect(
      sigc::mem_fun(*this, &MyWindow::view_map));


  touchselector_.set_print_func(
    sigc::mem_fun(*this, &MyWindow::picker_button_print_func));


  show_all_children();
}

//Destructor
MyWindow::~MyWindow()
{
}


/* implementation of the methods */

void MyWindow::on_value_changed()
{
  std::cout<<"Nomer: "<<touchselector_.get_selected_row_number()<<std::endl;
}


Glib::ustring MyWindow::picker_button_print_func()
{
  Gtk::TreeModel::iterator iter = touchselector_.get_selected(0);
  Gtk::TreeModel::Row row = *iter;
  Glib::ustring name = row[object_columns_.name_];
  Glib::ustring address = row[object_columns_.address_];
  return name + " " + address;
}


void MyWindow::view_map()
{
  Hildon::StackableWindow* stackableMap = new Hildon::StackableWindow;
  stackableMap->set_title("Map");

  Gtk::Image * mapImage = new Gtk::Image("images/map.png");

  Gtk::Button* button;
  button = new Gtk::Button();
  button->set_image((Gtk::Widget&)(*mapImage));
  stackableMap->add((Gtk::Widget&)(*button));
  stackableMap->show_all();

  std::cout << "Map shown." << std::endl;
}


void MyWindow::view_inspection()
{
  Hildon::StackableWindow* stackableIns = new Hildon::StackableWindow;
  stackableIns->set_title("Inspection card");

  stackableIns->add((Gtk::HButtonBox&)(hBox_));
  stackableIns->show_all();

  //AT THIS POINT MUST EMPTY STACKABLE WINDOW FROM hBox_

  std::cout<<"inspection card shown."<<std::endl;
}

void toggled()
{
	//std::cout<<"Button toggled: current state="<<chkButton_.get_active()<<std::endl;
}

